// TODO add standard boilerplate header stuff, and a quick explanation for what's going on here

// Generates a simple beep sound, for general purpose needs
void beep()
{
  beep_tick();
}

// Generates a middle-frequency sound, used for the ticking of the clock
void beep_tick()
{
  buzz(10, 2);
}

// Generates a higher sound, used when you get a point
void beep_point()
{
  buzz(10, 1);
}

// Generates a low sound, used for the end of the round
void beep_end()
{
  buzz(20, 4);
  delay(20);
  buzz(250, 4);
}

// Generate a tone for the specified duration using Arduino 0018's new tone feature
/*
void buzz(unsigned int duration_ms, unsigned int frequency_hz)
{
  // *buzz*
  output_string(BUZZ_STR, 1, 0);
  tone(SPEAKER, frequency_hz, duration_ms);
  delay(duration_ms); // TODO do we need this here? tone doesn't require it.
}
*/

/* TODO can we just replace this with the buzz above? Too bad the arduino docs aren't more clear about what hardware their functions use. */
void buzz(unsigned int duration, unsigned int delay_time)
{
  //not the best way to do it by a long shot...
  //I'd like to use PWM on this pin, but it appears that as of
  //arduino-0017, the LiquidCrystal library uses delayMicroseconds a lot
  //and that function disables interrupts.

  //It's set to be fixed in the Arduino-0018 release.
  //I've used the TimerOne library for this in the past, and it works well.

  long time = millis();
  int i;
  
  //*buzz*
  output_string(BUZZ_STR, 1, 0);
  
  while (1)
  {
    if (millis() >= time + duration)
    {
      break;
    }

    for (i = 0; i < 10; i++)
    {

      digitalWrite(SPEAKER_PIN, HIGH);
      delay(delay_time);
      digitalWrite(SPEAKER_PIN, LOW);
      delay(delay_time);
    }
  }
}

