#include <avr/pgmspace.h>

#define LARGEST_STRING_LENGTH 60
#define LCD_COLS 16
//help messages start at 0 (TODO what does this mean?)

// usb serial api help:
prog_char string_0[] PROGMEM = "Help: (press h for help)\n";   
prog_char string_1[] PROGMEM = "Words and category titles can only be 16 characters long!";
prog_char string_2[] PROGMEM = "x";
prog_char string_3[] PROGMEM = "cCATEGORYTITLEXXX        Add new category";
prog_char string_4[] PROGMEM = "aCCC NEWWORDXXXXXXXXX    Add new word in category CCC.";
prog_char string_5[] PROGMEM = "n                        Get the number of categories.";
prog_char string_6[] PROGMEM = "wCCC                     Get the number of words in category CCC.";
prog_char string_7[] PROGMEM = "tCCC                     Retrieve the title of category CCC as up to 16 characters.";
prog_char string_8[] PROGMEM = "fCCC WWWWW               Fetch word WWWWW from category CCC as up to 16 characters.";
prog_char string_9[] PROGMEM = "b                        List all categories and words";
prog_char string_10[] PROGMEM = "Entering USB Mode";   
prog_char string_11[] PROGMEM = "No words in that category!";
prog_char string_12[] PROGMEM = "Round over!     Score: ";
prog_char string_13[] PROGMEM = "Tests complete.";
prog_char string_14[] PROGMEM = "No categories defined";
prog_char string_15[] PROGMEM = "10 second button test beginning.";
prog_char string_16[] PROGMEM = "Button 1 released.";
prog_char string_17[] PROGMEM = "Button 1 depressed.";
prog_char string_18[] PROGMEM = "Nerdle       by Wayne and Layne";
prog_char string_19[] PROGMEM = "Choose category:";
prog_char string_20[] PROGMEM = "MAIN SCREEN TURN ON";
prog_char string_21[] PROGMEM = "*buzz*";
prog_char string_22[] PROGMEM = "USB mode";
prog_char string_23[] PROGMEM = "  wayneandlayne.com/nerdle";
prog_char string_24[] PROGMEM = "    *Paused*     Press Up Button";
prog_char string_25[] PROGMEM = "Exiting.";
prog_char string_26[] PROGMEM = "Category full.";
prog_char string_27[] PROGMEM = "No more available categories.";
prog_char string_28[] PROGMEM = "Adding category";
prog_char string_29[] PROGMEM = "Adding word";
prog_char string_30[] PROGMEM = "Clearing";
prog_char string_31[] PROGMEM = "Score: ";


PGM_P string_table[] PROGMEM =
{   
  string_0,
  string_1,
  string_2,
  string_3,
  string_4,
  string_5,
  string_6,
  string_7,
  string_8,
  string_9,
  string_10,
  string_11,
  string_12,
  string_13,
  string_14,
  string_15,
  string_16,
  string_17,
  string_18,
  string_19,
  string_20,
  string_21,
  string_22,
  string_23,
  string_24,
  string_25,
  string_26,
  string_27,
  string_28,
  string_29,
  string_30,
  string_31
};

void output_string(byte index, byte output_serial, byte output_lcd)
{
  char buffer[LARGEST_STRING_LENGTH];

  strcpy_P(buffer, (char*)pgm_read_word(&(string_table[index])));
  output_string(buffer, output_serial, output_lcd);
}

void display_end_of_round(unsigned int round_score)
{
  char number[NUMBER_SIZE];
  itoa(round_score, number, 10);
  char buffer[35]; // TODO why 35?
  strcpy_P(buffer, (char*)pgm_read_word(&(string_table[ROUND_OVER_INDEX])));
  byte startpos = strlen(buffer);
  //int i;
  //for (i = 0; i < NUMBER_SIZE; i++);
  //{
  //  buffer[startposi] = number[i];
  //}
  //buffer[startpos+i] = 0;
  strcpy(buffer+22, number);

  output_string(buffer, 1, 1);
  delay(3000); // TODO magic number
}
